
clear all; close all; clc; load('data')


alpha=0.01; 

Nmax=1000;


J=@(u,y) alpha*sum(abs(u))+0.5*beta*sum(u.^2)+0.5*sum((y-z_aux).^2);
u=zeros(Nx,1); Bu=B*u; y=A_inv*[0; Bu(2:end-1,1);0];
J_val=zeros(Nmax,1); J_val(1,1)=J(u,y); J_old=J_val(1,1);

tic
for k=2:Nmax
    
    Nmax-k+1
    
    lambda=10;
    
    aux=((beta+1/lambda)*eye(Nx)+B'*(A_inv)'*A_inv*B)^-1*(u/lambda+B'*A_inv'*z_aux);
    u=shrink(aux, alpha*lambda);
    Bu=B*u; y=A_inv*[0; Bu(2:end-1,1);0];
    
    J_val(k,1)=J(u,y);
    if J_val(k,1)>J_old
        break;
    end
    J_old=J_val(k,1);
    
end
comp_time=toc

save('res_alpha_staz');



fig=figure; plot(1:Nmax,J_val); saveas(fig,'J_alpha_staz.jpg');


fig=figure; 
subplot(1,2,1); plot(x,u); hold on; plot(x,v,'r','linewidth',3);
hh=xlabel('$x$'); set(hh,'Interpreter','latex','FontSize',14);
hh=ylabel('$u$'); set(hh,'Interpreter','latex','FontSize',14);

subplot(1,2,2); plot(x,y); hold on; plot(x,z_aux,'r','linewidth',3);
hh=xlabel('$x$'); set(hh,'Interpreter','latex','FontSize',14);
hh=ylabel('$y$'); set(hh,'Interpreter','latex','FontSize',14);

saveas(fig,'uy_alpha_staz.jpg'); pause; close all;


    